unit mplay;

interface

const
  mok         =  0;
  mfnotfound  = -1;
  mfread      = -2;
  mfclose     = -3;
  mfdataerror = -4;

var
  merror : integer;
  keyp   : boolean;

procedure playfile (name : string);

implementation

uses
  crt;

const
  NC = 1;
  NCd= 2;
  ND = 3;
  NDd= 4;
  NE = 5;
  NF = 6;
  NFd= 7;
  NG = 8;
  NGd= 9;
  NA =10;
  NB =11;
  NH =12;
  NP = 0;

var
  t   : text;
  d8  : word;
  l   : byte;
  okt : integer;
  s   : string;
  key : boolean;
  tri : byte;

function upstr (s : string) : string;
var i : byte;
begin
  if s <> '' then
    for i := 1 to length(s) do s[i] := upcase(s[i]);
  upstr := s
end;

function nota (s : string) : byte;
var
  n : byte;
begin
  case s[1] of
    'C' : n := NC;
    'D' : n := ND;
    'E' : n := NE;
    'F' : n := NF;
    'G' : n := NG;
    'H' : n := NH;
    'A' : n := NA;
    'B' : n := NB;
    'P' : n := NP
  end;
  if length(s) = 2 then
    case s[2] of
      '#','+' : inc (n);
      '-'     : dec (n)
    end;
  nota := n
end;

function freq (okt : integer; nota : byte) : word;
begin
  if nota = NP then freq := 0
  else
    freq := round (440 * exp(ln(2)*(okt-1-(10-nota)/12)))
end;

procedure zvuk (nota : byte; okt : integer; del : word);
var c : char;
begin
  if nota <> NP then sound (freq (okt, nota));
  delay (del);
  nosound;
  if not keypressed then exit;
  c := readkey;
  while keypressed do readKey;
  if upcase(c) = 'P' then while not keypressed do;
  while keypressed do readKey;
  if (upcase(c) <> 'P') and keyp then key := true
end;

function stn (s : string) : integer;
var
  n,
  code : integer;
begin
  val (s, n, code);
  if code <> 0 then n := 0;
  stn := n
end;

procedure play (s : string);
var
  n,
  i : byte;
  del : word;
begin
  if s[0] > #0 then while s[1] = ' ' do s := copy(s,2,length(s)-1);
  if s[0] > #0 then while s[byte(s[0])] = ' ' do dec(s[0]);
  if s = '' then exit;
  s := upstr(s);
  i := 1;
  while i <= length(s) do
    begin
      if key then exit;
      case s[i] of
        ';' : exit;
        'O' : begin okt := stn(s[i+1]); inc (i,2) end;
        '>' : begin inc (okt); inc (i) end;
        '<' : begin dec (okt); inc (i) end;
        'L' :
          begin
            if (i+2 <= length(s)) and (s[i+2] in ['0'..'9']) then
              begin l := stn(s[i+1]+s[i+2]); inc (i,3) end
            else
              begin l := stn(s[i+1]); inc (i,2) end
          end;
        '3' : begin tri := 3; inc (i) end;
        '6' : begin tri := 6; inc (i) end;
        'A'..'H','P' :
          begin
            if (i+1 <= length(s)) and (s[i+1] in ['#','+','-']) then
              begin n := nota(s[i]+s[i+1]); inc (i,2) end
            else
              begin n := nota(s[i]); inc (i) end;
            del := 8*d8 div l;
            if (i+1 <= length(s)) and (s[i]+s[i+1] = '..') then
              begin inc (del,3*del div 4); inc (i,2) end
            else
              if (i <= length(s)) and (s[i] = '.') then
                begin inc (del,del div 2); inc (i) end;
            if tri > 0 then
              begin
                del := (2*del) div 3;
                dec (tri)
              end;
            zvuk (n, okt, del)
          end;
        else inc (i)
      end;
    end;
end;

procedure playfile (name : string);
begin
  key := false;
  assign (t, name);
  {$I-} reset (t); {$I+}
  if ioresult <> 0 then
    begin
      merror := mfnotfound;
      exit
    end;
  {$i-} readln (t, d8); {$i+}
  if ioresult <> 0 then
    begin
      merror := mfdataerror;
      exit
    end;
  while not eof(t) do
    begin
      {$i-} readln (t, s); {$i+}
      if ioresult <> 0 then
        begin
          merror := mfread;
          exit
        end;
      play (s);
      if key then break
    end;
  {$i-} close (t); {$i+}
  if ioresult <> 0 then
    begin
      merror := mfclose;
      exit
    end;
  merror := mok
end;

begin
  keyp := true;
  tri := 0
end.
